#include<fstream>
#include<string>
#include<algorithm>
#include<iostream>
#define f first
#define s second
#define mp make_pair
using namespace std;


int readInt(istream &in, int lb = (1U<<31), int ub = (1U<<31)-1) {
	int ret;
	
	if(!(in >> ret) )
		throw 1;
	
	if(ret < lb || ret > ub)
		throw 1;
	
	return ret;
}


string readString(istream &in) {
	string ret;
	
	if(!(in >> ret) )
		throw 1;
	
	return ret;
}




bool isCycleCover(vector<pair<int, int> > edge) {
	vector<int> pts;
	
	for(auto c : edge) {
		pts.push_back(c.f);
		pts.push_back(c.s);
	}
	
	sort(pts.begin(), pts.end() );
	vector<int> toAdd = pts;
	pts.resize(unique(pts.begin(), pts.end() ) - pts.begin() );
	
	
	int cur = 0;
	
	for(size_t i=0, aind=0; i<pts.size();i++) {
		while(aind < toAdd.size() && pts[i] == toAdd[aind])
			cur++, aind++;
		
		if(cur%2 == 1)
			return false;
	}
	
	return true;
}











int main(int argc, char ** args) {
	if(argc != 4) {
		cout << "Invalid no. of arguments. Usage:\n" << args[0] << " [input file] [correct solution] [solution to test]\n";
		return 0;
	}
	
	ifstream inp(args[1]), cor(args[2]), out(args[3]);
	string correct;
	cor >> correct;
	
	vector<pair<int, int> > span, edge;
	
	int L, n, m;
	{
		inp >> L >> n;
		span.resize(n);
		
		for(int i=0;i<n;i++) {
			inp >> span[i].f >> span[i].s;
			span[i].s++;
		}
		
		inp >> m;
		edge.resize(m);
		
		for(int i=0;i<m;i++) {
			inp >> edge[i].f >> edge[i].s;
			edge[i].s++;
		}
	}
	
	
	//------------------------------------------------
	//Actually assess the competitior solution
	
	try
	{
		string given = readString(out);
		
		if(given == "JAH") {
			
			vector<bool> field(edge.size(), false);
			
			//Try reading the first integer
			try {
				field[0] = readInt(out, 0, 1);
			}
			catch(int a) {
				if(correct == "JAH")
                { cout << "0.8\n"; cerr << "OK\n"; }
				else
                { cout << "0\n"; cerr << "Wrong answer\n"; }
				
				return 0;
			}
			
			//Read the rest
			for(size_t i=1;i<edge.size();i++)
				field[i] = readInt(out, 0, 1);
			
			
			for(size_t i=0;i<edge.size();i++)
				if(field[i])
					span.push_back(edge[i]);
			
			
			//Finally test the solution
			if(isCycleCover(span) )
            { cout << "1\n"; cerr << "OK\n"; }
			else
            { cout << "0\n"; cerr << "Wrong answer\n"; }
			
		}
		else if(given == "EI") {
			
			if(correct == "EI")
            { cout << "1\n"; cerr << "OK\n"; }
			else
            { cout << "0\n"; cerr <<"Wrong answer\n"; }
		}
		else
			throw 1;
	}
	catch(int a) {
		cout << "0\n"; cerr << "Presentation error\n";
	}
	
	return 0;
}






































