#Author: Oliver-Matis Lill
#Solution for groups 2 and 3
#This solution first orients all the on segments
#so we would know which way the would be passed
#in a directed cycle cover.
#For each orientation it just tries to find a
#saturated matching between the "entrance" and
#"exit" nodes of each on segment.
#If such matching is found, deduce the solution.
#Time Complexity: O(2^(2N) N + MN)
import sys

inf = open('diskosis.txt', 'r')
outf = open('diskoval.txt', 'w')

L = int(inf.readline())
N = int(inf.readline())

pts=[]
span=[]

for i in range(N):
	a, b = map(int, inf.readline().split(' ') )
	b+=1
	pts.append(a)
	pts.append(b)
	span.append(a)
	span.append(b)


M = int(inf.readline())
edge=[]

for i in range(M):
	a, b = map(int, inf.readline().split(' ') )
	b+=1
	pts.append(a)
	pts.append(b)
	edge.append( (a, b) )


pts = list(set(pts))
ptind = {}

for i in range(len(pts)):
	ptind[pts[i]] = i
	
for i in range(2*N):
	span[i] = ptind[span[i]]


conn = [[] for i in range(len(pts))]

for i in range(M):
	edge[i] = (ptind[edge[i][0]], ptind[edge[i][1]])
	conn[edge[i][0]].append( (edge[i][1], i) )
	conn[edge[i][1]].append( (edge[i][0], i) )


#---------------------------------------------------
#Calculate a reachability from origin

def reach(start):
	ret = [False for i in range(len(pts))]
	ret[start] = True
	front = [start]
	ind = [0]
	
	while(len(front) > 0):
		cur = front[len(front)-1]
		cind = ind[len(ind)-1]
		ind[len(ind)-1]+=1
		
		if(cind < len(conn[cur])):
			next = conn[cur][cind][0]
			if not ret[next]:
				ret[next] = True
				front.append(next)
				ind.append(0)
			
		else:
			front.pop()
			ind.pop()
	
	return ret




ptreach = [[False for i in range(2*N)] for j in range(2*N)]

for i in range(2*N):	
	curReach = reach(span[i])
	
	for j in range(2*N):
		if curReach[span[j]]:
			ptreach[i][j] = True




#Function to get the edges you need to flip in moving from a to b

def flip(start, dest):
	explr = [False for i in range(len(pts))]
	explr[start] = True
	front = [start]
	ind = [0]
	edge = []
	
	while(len(front) > 0):
		
		cur = front[len(front)-1]
		cind = ind[len(ind)-1]
		ind[len(ind)-1]+=1
		
		if(cur == dest):
			return edge
		
		if(cind < len(conn[cur])):
			next = conn[cur][cind][0]
			if not explr[next]:
				explr[next] = True
				front.append(next)
				ind.append(0)
				edge.append(conn[cur][cind][1])
		
		else:
			front.pop()
			ind.pop()
			if(len(edge) > 0):
				edge.pop()
	
	return None






#---------------------------------------------------------------
#Actually try all the orientations


for orient in range(1 << N):
	creach = [[False for i in range(N)] for j in range(N)]
	side = [int( (orient & (1 << i) ) != 0 ) for i in range(N)]
	
	for i in range(N):
		for j in range(N):
			creach[i][j] = ptreach[2*i+side[i]] [2*j+1-side[j]]
	
	#Finally the travelling salesman DP to calculate reachability
	valid=[False for j in range(2 ** N)]
	prev = [-1 for j in range(2 ** N)]
	valid[0] = True
	
	for comb in range(0, 2**N - 1):
		if valid[comb]:
			cur = 0
			for i in range(0, N):
				if ((1<<i) & comb) != 0:
					cur+=1
			
			for i in range(0, N):
				if ((1 << i) & comb) == 0 and creach[cur][i]:
					next = comb + (1 << i)
					valid[next] = True
					prev[next] = i
	
	#found a valid solution
	if valid[2**N - 1]:
		ccomb = 2**N-1
		cur = N-1
		
		edges = []
		
		while cur >= 0:
			p1 = 2*cur + side[cur]
			p2 = 2*prev[ccomb]+1 - side[prev[ccomb]]
			
			edges += flip(span[p1], span[p2])
			ccomb -= (1 << prev[ccomb])
			cur -= 1
		
		shouldswitch = [0 for i in range(M)]
		for e in edges:
			shouldswitch[e] = (shouldswitch[e] + 1)%2
		
		outf.write("JAH\n")
		for s in shouldswitch:
			outf.write(str(s) + ' ')
		outf.write('\n')
		sys.exit()
	


outf.write("EI\n")












































