#Author: Oliver-Matis Lill
#Python version of the full solution
#Detailed description on c++ solution
import sys

f=open('diskosis.txt', 'r')
outf = open('diskoval.txt', 'w')

L=int(f.readline())
N=int(f.readline())

span=[]
pts=[]

for i in range(N):
	a, b = map(int, f.readline().split(' ') )
	span.append( (a, b+1) )
	pts.append(a)
	pts.append(b+1)



M = int(f.readline())

edge=[]

for i in range(M):
	a, b = map(int, f.readline().split(' ') )
	edge.append( (a, b+1) )
	pts.append(a)
	pts.append(b+1)


pts = list(set(pts))
pointIndex = {}

for i in range(len(pts) ):
	pointIndex[pts[i]] = i


#-------------------------------------------------------
#Create the tree structure
conn = [ [] for i in range(len(pts) ) ]

for i in range(len(edge)):
	a, b = edge[i]
	conn[pointIndex[a]].append( (pointIndex[b], i) )
	conn[pointIndex[b]].append( (pointIndex[a], i) )



master = [-1 for i in range(len(pts) ) ]

def exploreRoot(root):
	if not master[root] == -1:
		return
	
	front = [root]
	
	i = 0
	while i < len(front):
		cur = front[i]
		i+=1
		
		if not master[cur] == -1:
			continue
			
		master[cur] = root
		
		for next in conn[cur]:
			front.append(next[0])


for i in range(len(pts) ):
	exploreRoot(i)
		
	

#-----------------------------------------------------
#Eulerian cycle finding algorithm

toSwitch = [0 for i in range(len(pts) ) ]
degree = [0 for i in range(len(pts) )]
#format: [next, counterpartIndex, used]
econn = [[] for i in range(len(pts)) ]

#add the initial spans
for (x, y) in span:
	a, b = pointIndex[x], pointIndex[y]
	
	aInd = len(econn[master[a]])
	econn[master[a]].append([a, b, -1, False])
	
	bInd = len(econn[master[b]])
	econn[master[b]].append([b, a, -1, False])
	
	econn[master[a]][aInd][2] = bInd
	econn[master[b]][bInd][2] = aInd
	
	degree[master[a]]+=1
	degree[master[b]]+=1



#Check if a solution exists
for d in degree:
	if d % 2 == 1:
		outf.write("EI\n")
		sys.exit()



#Actual cycle finding

ind = [0 for i in range(len(pts)) ]

def getCycle(start):
	front = [start]
	
	while(len(front) > 0):
		cur = front[len(front)-1]
		
		while ind[cur] < len(econn[cur]) and econn[cur][ind[cur]][3]:
			ind[cur]+=1
		
		if(ind[cur] < len(econn[cur]) ):
			edge = econn[cur][ind[cur]]
			
			toSwitch[cur]+=1
			toSwitch[edge[0]] += 1
			toSwitch[edge[1]] += 1
			toSwitch[master[edge[1]]] += 1
			
			econn[cur][ind[cur]][3] = True
			econn[master[edge[1]]] [edge[2]] [3] = True
			
			front.append(master[edge[1]])
		else:
			front.pop()


for i in range(len(pts)):
	if master[i] == i:
		getCycle(i)



#-------------------------------------------------------------
#finally create the appropriate strategy

switch = [0 for i in range(M)]

explr = [False for i in range(len(pts) )]

def iterDFS(start):
	front = [start]
	parent = [-1]
	find = [0]
	subsum = [0]
	
	while(len(front) > 0):
		cur = front[len(front) - 1]
		cind = find[len(find) - 1]
		find[len(find)-1] += 1
		explr[cur] = True
		
		if cind < len(conn[cur]):
			edge = conn[cur][cind]
			cind+=1
			
			if not explr[edge[0]]:
				front.append(edge[0])
				parent.append(edge[1])
				find.append(0)
				subsum.append(toSwitch[edge[0]])
				
		else:
			curparent = parent[len(parent)-1]
			cursum = subsum[len(subsum)-1]
			
			if not (curparent == -1):
				switch[curparent] = cursum%2
			
			front.pop()
			parent.pop()
			find.pop()
			subsum.pop()
			
			if(len(subsum) > 0):
				subsum[len(subsum)-1] += cursum


for i in range(len(pts)):
	iterDFS(i)


#And actually output the result
outf.write("JAH\n")








































